#ifndef TESSST_H_
#define TESSST_H_



#include "c4d.h"
#include "c4d_graphview.h"
#include "main.h"
#include "dexample.h"

#define DATATYPE_DEFAULTLONG	 1000
#define DATATYPE_DEFAULTSTRING 1001

//CustomProperty g_dataTypeProps[] =
//{
//	{ CUSTOMTYPE::LONG, DATATYPE_DEFAULTLONG, "DEFAULTLONG" },
//	{ CUSTOMTYPE::STRING, DATATYPE_DEFAULTLONG, "DEFAULTSTRING" },
//	{	CUSTOMTYPE::END, 0, nullptr }
//};

class ExampleDataType
{
};

class iExampleDataType : public iCustomDataType<ExampleDataType>
{
	friend class ExampleDataTypeClass;

	Int32	 ldata;
	String sdata;
	Vector vdata;

public:
	iExampleDataType();
};

#define CUSTOMDATATYPE_EXAMPLE 123123123

//Int32 g_convfrom[] =
//{
//	ID_GV_VALUE_TYPE_STRING,	// DA_STRING,
//	ID_GV_VALUE_TYPE_INTEGER,	// DA_LONG,
//	CUSTOMDATATYPE_EXAMPLE,
//	CUSTOMDATATYPE_SPLINE,
//	400006000,	// ID_GV_VALUE_TYPE_GENERAL_OBJECT
//};
//
//Int32 g_convto[] =
//{
//	ID_GV_VALUE_TYPE_STRING,	// DA_STRING,
//	ID_GV_VALUE_TYPE_INTEGER,	// DA_LONG,
//	// CUSTOMDATATYPE_SPLINE,
//	400006000,
//};

//struct GvObject
//{
//	BaseList2D*	object;
//	Int32				type;
//};

class ExampleDataTypeClass : public CustomDataTypeClass
{
	INSTANCEOF(ExampleDataTypeClass, CustomDataTypeClass)

public:
	virtual Int32 GetId();

	virtual CustomDataType* AllocData();
	
	virtual void FreeData(CustomDataType* data);
	
	virtual Bool CopyData(const CustomDataType* src, CustomDataType* dst, AliasTrans* aliastrans);

	virtual Int32 Compare(const CustomDataType* d1, const CustomDataType* d2);
	
	virtual Bool WriteData(const CustomDataType* t_d, HyperFile* hf);
	
	virtual Bool ReadData(CustomDataType* t_d, HyperFile* hf, Int32 level);
	
	virtual const Char* GetResourceSym();
	
	virtual CustomProperty* GetProperties();

	virtual void GetDefaultProperties(BaseContainer& data);	// fill default DESC_xxx values;;

	virtual Int32 GetConversionsFrom(Int32*& table);
	
	virtual GvError ConvertFromGv(Int32 type, const void* const src, Int32 cpu_id, CustomDataType* dst);

	virtual Int32 GetConversionsTo(Int32*& table);
	
	virtual GvError ConvertToGv(Int32 type, const CustomDataType* src, void* dst, Int32 cpu_id);
	
	virtual GvValueFlags GetCalculationFlags();
	
	virtual GvError Calculate(Int32 calculation, const CustomDataType* src1, const CustomDataType* src2, CustomDataType* dst, Float parm1);
	
	virtual Bool _GetDescription(const CustomDataType* data, Description& desc, DESCFLAGS_DESC& flags, const BaseContainer& parentdescription, DescID* singledescid);
	
	virtual Bool GetParameter(const CustomDataType* data, const DescID& id, GeData& t_data, DESCFLAGS_GET& flags);
	
	virtual Bool SetDParameter(CustomDataType* data, const DescID& id, const GeData& t_data, DESCFLAGS_SET& flags);

	virtual Bool GetEnabling(const CustomDataType* data, const DescID& id, const GeData& t_data, DESCFLAGS_ENABLE& flags, const BaseContainer* itemdesc);
};

//
//Bool RegisterExampleDataType()
//{
//	RegisterDescription(CUSTOMDATATYPE_EXAMPLE, "Dexample"_s);
//
//	if (!RegisterCustomDataTypePlugin(
//				"C++ SDK ExampleDataType"_s,
//				CUSTOMDATATYPE_INFO_LOADSAVE |
//				CUSTOMDATATYPE_INFO_TOGGLEDISPLAY |
//				CUSTOMDATATYPE_INFO_HASSUBDESCRIPTION |
//				0,
//				NewObjClear(ExampleDataTypeClass),
//				1))
//		return false;
//
//	return true;
//}



#endif //TESSST_H_