#include "nexus.h"


#include "datatype.h"
#include "meindatatype.h"

Bool Nexus::Init(GeListNode* node)
{
	BaseTag* tag = (BaseTag*)node;
	BaseContainer* data = tag->GetDataInstance();

	// Setting data:
	GeData splvsGeData(ID_DTYPE_SPLINE_VIS, DEFAULTVALUE);
	iSplineVisDataType* splvs = (iSplineVisDataType*)splvsGeData.GetCustomDataType(ID_DTYPE_SPLINE_VIS);

	Gradient* grr = splvs->_gradient;
	
	if (grr != nullptr)
	{
		grr->FlushKnots();
		{
			GradientKnot knot;
			knot.pos = 0.0;
			knot.col = Vector(0, 1, 0);
			knot.bias = 0.8;
			grr->InsertKnot(knot);
		}
		{
			GradientKnot knot;
			knot.pos = 0.5;
			knot.col = Vector(0, 0, 1);
			knot.bias = 0.2;
			grr->InsertKnot(knot);
		}
		{
			GradientKnot knot;
			knot.pos = 1.0;
			knot.col = Vector(1, 1, 0);
			grr->InsertKnot(knot);
		}
	}

	data->SetData(ANIMATION_CLONER_SPLVIS, splvsGeData);



	////Mein Data
	//GeData meinGeData(MEINDATATYPE_ID, DEFAULTVALUE);
	//ace::MeinDataType* testMeinData = (ace::MeinDataType*)meinGeData.GetCustomDataType(MEINDATATYPE_ID);
	//testMeinData->Set69();
	//data->SetData(TEST_MEINDATA, meinGeData);
	//Float value = ((ace::MeinDataType*)(data->GetCustomDataType(TEST_MEINDATA, MEINDATATYPE_ID)))->Get69();
	return true;
}



Bool Nexus::Message(GeListNode* node, Int32 type, void* data)
{



	BaseTag* tag = (BaseTag*)node;
	BaseContainer* bc = tag->GetDataInstance();



	auto dots = static_cast<iSplineVisDataType*>(bc->GetData(ANIMATION_CLONER_SPLVIS).GetCustomDataType(ID_DTYPE_SPLINE_VIS));
	ApplicationOutput("Dots GetParameter() size = " + String::IntToString(dots ? dots->_points.GetCount() : -1));

	return SUPER::Message(node, type, data);
}
//
//Bool Nexus::Read(GeListNode* node, HyperFile* hf, Int32 level)
//{
//
//	if (level >= 0)
//	{
//		hf->ReadFloat(&offset);
//	}
//
//
//
//	return SUPER::Read(node,  hf, level)
//}

Nexus::~Nexus()
{
	ApplicationOutput("Deleted dat tag"_s);
}
